# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`golang`](#golang): Install go in `/usr/local/go` and `/usr/local/bin`

## Classes

### <a name="golang"></a>`golang`

`/usr/local/share/` *must* exist.

Most people will not need to change any parameter other than `$version`.

#### Parameters

The following parameters are available in the `golang` class:

* [`ensure`](#-golang--ensure)
* [`version`](#-golang--version)
* [`link_binaries`](#-golang--link_binaries)
* [`source_prefix`](#-golang--source_prefix)
* [`os`](#-golang--os)
* [`arch`](#-golang--arch)
* [`source`](#-golang--source)

##### <a name="-golang--ensure"></a>`ensure`

Data type: `Enum[present, absent]`

* `present`: Make sure go is installed.
* `absent`: Make sure go is uninstalled.

Default value: `present`

##### <a name="-golang--version"></a>`version`

Data type: `String[1]`

The version of Go to install. You can find the latest version number at
https://go.dev/dl/

Default value: `'1.19.1'`

##### <a name="-golang--link_binaries"></a>`link_binaries`

Data type: `Array[String[1]]`

The binaries to symlink into `/usr/local/bin`.

Default value: `['go', 'gofmt']`

##### <a name="-golang--source_prefix"></a>`source_prefix`

Data type: `String[1]`

URL to directory that contains the archive to download.

Default value: `'https://go.dev/dl'`

##### <a name="-golang--os"></a>`os`

Data type: `String[1]`

The OS to use to determine what archive to download.

Default value:

```puppet
$facts['kernel'] ? {
    'Linux'  => 'linux',
    'Darwin' => 'darwin',
    default  => $facts['kernel']
```

##### <a name="-golang--arch"></a>`arch`

Data type: `String[1]`

The architecture to use to determine what archive to download.

Default value:

```puppet
$facts['os']['hardware'] ? {
    undef     => 'amd64', # Assume amd64 if os.hardware is missing.
    'aarch64' => 'arm64',
    'armv7l'  => 'armv6l',
    'i686'    => '386',
    'x86_64'  => 'amd64',
    default   => $facts['os']['hardware']
```

##### <a name="-golang--source"></a>`source`

Data type: `String[1]`

URL to actual archive.

Default value: `"${source_prefix}/go${version}.${os}-${arch}.tar.gz"`

